﻿
<script type="text/javascript" src="https://code.jquery.com/jquery-3.5.1.min.js"></script>
<script type="text/javascript" src="https://cdn3.devexpress.com/jslib/21.1.6/js/dx.all.js"></script>
<script src="~/js/sweetalert.min.js"></script>
<script type="text/javascript">
    //$("#NgayDangKy").inputmask("d/m/y", {
    //    placeholder: "__/__/____"
    //});
</script>
<script type="text/javascript">
    function createCookie(name, value, days) {
        var expires;

        if (days) {
            var date = new Date();
            date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
            expires = "; expires=" + date.toGMTString();
        } else {
            expires = "";
        }
        document.cookie = encodeURIComponent(name) + "=" + encodeURIComponent(value) + expires + "; path=/";
    }

    function readCookie(name) {
        var nameEQ = encodeURIComponent(name) + "=";
        var ca = document.cookie.split(';');
        for (var i = 0; i < ca.length; i++) {
            var c = ca[i];
            while (c.charAt(0) === ' ')
                c = c.substring(1, c.length);
            if (c.indexOf(nameEQ) === 0)
                return decodeURIComponent(c.substring(nameEQ.length, c.length));
        }
        return null;
    }

    function eraseCookie(name) {
        createCookie(name, "", -1);
    }
    $(document).ready(function () {
        LoadDataTable();
    });
    function LoadDataTable() {
        $.ajax({
            type: "GET",
            url: '@Url.Action("GetAllPhieuDangKyRaVaoCong", "PhieuDangKyRaVaoCong")',
            dataType: 'text',
            success: function (data) {
                console.log(JSON.parse(data));
                $("#gridContainer").dxDataGrid({
                    dataSource: JSON.parse(data),
                    columns: [
                        {
                            dataField: "STT",
                            caption: "#",
                            width:50
                        },
                        {
                            dataField: "TenDonVi",
                            caption: "Đơn vị"
                        },
                        {
                            dataField: "NgayDangKyTuNgay",
                            caption: "Từ ngày",
                            dataType: 'date',
                            format: 'dd/MM/yyyy'
                        },
                        {
                            dataField: "NgayDangKyDenNgay",
                            caption: "Đến ngày",
                            dataType: 'date',
                            format: 'dd/MM/yyyy'
                        },
                        {
                            dataField: "TinhTrang",
                            caption: "Tình trạng",
                            cellTemplate: function (container, options) {
                                if (options.value == "MoiTao") {
                                    $("<span class='btn-secondary btn-sm'>").append("Mới tạo").appendTo(container);
                                } else if (options.value == "ChoYTeDuyet"){
                                    $("<span class='btn-primary btn-sm'>").append("Chờ y tế duyệt").appendTo(container);
                                }else if (options.value == "ChoPhuTrachDuyet"){
                                    $("<span class='btn-primary btn-sm'>").append("Chờ phụ trách duyệt").appendTo(container);
                                }else if (options.value == "DaDuyet"){
                                    $("<span class='btn-success btn-sm'>").append("Đã duyệt").appendTo(container);
                                }
                            }
                        },
                        {
                            dataField: "GhiChu",
                            caption: "Ghi chú",
                        },
                        {
                            dataField: "NgayTao",
                            caption: "Ngày tạo",
                            dataType: 'date',
                            format: 'dd/MM/yyyy hh:mm:ss'
                        },
                        {
                            dataField: "HoTen",
                            caption: "Người tạo",
                        },
                        {
                            dataField: "",
                            caption: "Hành động",
                            cellTemplate: function (container, options) {
                                $("<a class='btn btn-primary btn-sm' target='' href='@Url.Action("ChiTietPhieu", "PhieuDangKyRaVaoCong")?idPhieu="+options.data.Id+"'>").append("<i class='fa fa-edit'></i>Xem phiếu").appendTo(container);
                                $("<span data-toggle='modal' data-target='#frmChonNgaySaoChepPhieu' onclick='CopyPhieu("+options.data.Id+")' class='ml-2 btn btn-success btn-sm'>").append("<i class='fa fa-copy'></i>Sao chép phiếu").appendTo(container);
                                $("<span onclick='XoaPhieu("+options.data.Id+")' class='ml-2 btn btn-danger btn-sm'>").append("<i class='fa fa-trash'></i>Xóa phiếu").appendTo(container);
                            }
                        }
                    ],
                    showBorders: true,
                    searchPanel: {
                        visible: true,
                        highlightCaseSensitive: true
                    },
                    headerFilter: {
                        visible: true
                    },
                    loadPanel: {
                        enabled: false
                    },
                    scrolling: {
                        useNative: true,
                        scrollByContent: true,
                        scrollByThumb: true,
                        showScrollbar: "always" // or "onScroll" | "always" | "never"
                    },
                    columnAutoWidth: true
                });

            },
            error: function (e) {
                swal({
                    title: "Lỗi cập nhật",
                    text: data,
                    type: 'error',
                    showCancelButtonClass: 'OK'
                });
            }
        });

        //LoadChart(dataSource);
    }
    function XoaPhieu(IdPhieu) {
        var cf = confirm("Bạn muốn xóa phiếu này");
        if (cf) {
            $.ajax({
                type: "POST",
                url: '@Url.Action("XoaPhieu", "PhieuDangKyRaVaoCong")',
                data: { IdPhieu: IdPhieu },
                dataType: 'text',
                success: function (data) {
                    if(data == "DELETED")
                        window.location.reload();
                    else
                        swal({
                            title: "Lỗi xóa phiếu",
                            text: "Chỉ xóa được phiếu mới tạo hoặc tạm dừng!",
                            type: 'error',
                            showCancelButtonClass: 'OK'
                        });
                },
                error: function (e) {
                    swal({
                        title: "Lỗi xóa phiếu",
                        text: "Vui lòng thử lại hoặc liên hệ TISC",
                        type: 'error',
                        showCancelButtonClass: 'OK'
                    });
                }
            });
        }
    }
    function CopyPhieu(IdPhieu) {
        createCookie('IdPhieu',IdPhieu,1);
    }
    $('.btnSaoChepPhieu').click(function () {
        jQuery("#loading").fadeIn();
        var NgayDangKyTuNgay = $('#NgayDangKyTuNgay').val();
        var NgayDangKyDenNgay = $('#NgayDangKyDenNgay').val();
        $.ajax({
                type: "POST",
                url: '@Url.Action("CopyPhieu", "PhieuDangKyRaVaoCong")',
                data: { IdPhieuTu: readCookie('IdPhieu'),NgayDangKyTuNgay:NgayDangKyTuNgay,NgayDangKyDenNgay:NgayDangKyDenNgay },
                dataType: 'text',
                success: function (data) {
                    jQuery("#loading").fadeOut();
                    if (parseInt(data) > 0) {
                        swal({
                            title: "Thành công",
                            text: "Đã sao chép phiếu thành công",
                            type: 'success',
                            confirmButtonColor: "#DD6B55",
                            confirmButtonText: "Mở phiếu vừa tạo",
                            showCancelButton: false,
                        },
                            function (isConfirm) {
                                if (isConfirm) {
                                    window.location.href = '@Url.Action("ChiTietPhieu", "PhieuDangKyRaVaoCong")?idPhieu=' + data;
                                }
                            }
                        );
                    } else {
                        swal({
                            title: "Lỗi sao chép phiếu",
                            text: "Vui lòng thử lại hoặc liên hệ TISC",
                            type: 'error',
                            showCancelButtonClass: 'OK'
                        });
                    }
                },
                error: function (e) {
                    jQuery("#loading").fadeOut();
                    swal({
                        title: "Lỗi xóa phiếu",
                        text: "Vui lòng thử lại hoặc liên hệ TISC",
                        type: 'error',
                        showCancelButtonClass: 'OK'
                    });
                }
            });
    });


    $('.btnTaoPhieuDangKyRaVaoCong').click(function () {
        var NgayDangKy = $('#NgayDangKy').val();
        var DonVi = $('#DonVi').val();
        var GhiChu = $('#GhiChu').val();
        if (NgayDangKy != '' && DonVi != '-1') {
            $.ajax({
                type: "POST",
                url: '@Url.Action("SavePhieuDangKyRaVaoCong", "PhieuDangKyRaVaoCong")',
                data: { NgayDangKy:NgayDangKy,DonVi:DonVi,GhiChu:GhiChu},
                dataType: 'text',
                success: function (data) {
                    console.log(data);

                },
                error: function (e) {
                    swal({
                        title: "Lỗi tạo phiếu",
                        text: "Vui lòng thử lại hoặc liên hệ TISC",
                        type: 'error',
                        showCancelButtonClass: 'OK'
                    });
                }
            });
        } else {

        }
    });
</script>